;TESTE.ASM    V1.0
;
; Rotinas de teste da PLACA "PENTA-CONTROLADORA"
MSG_LCD_SEL_1:		DB	' MODO   TESTE',0
MSG_LCD_SEL_2:		DB	'TESTE=',0
MSG_LCD_SEL_3:		DB	'SELEC=',0
MSG_LCD_SEL_9:		DB	'NAO !',0
MSG_SER_SEL_1:		DB	'MODO TESTE, SELECIONE OPCAO COM SW4',CR,LF,0
MSG_SER_SEL_2:		DB	'OPCAO TESTE = ',0
MSG_SER_SEL_3:		DB	'SELECIONADO TESTE = ',0
MSG_SER_SEL_9:		DB	'OPCAO INDISPONIVEL',CR,LF,0

MSG_SER_00:     DB              'TESTE DOS BARRAMENTOS. So sai com RESET.',CR,LF,0
MSG_LCD_00:     DB              'BARRAM.',0
MSG_SER_01:     DB              'Teste transmissao Serial. Deve aparecer o caracter (',55H,').',CR,LF,0
MSG_LCD_01:     DB              'SERIAL',0
MSG_SER_02:     DB              'Teste recepcao Serial. Mostra caracter no LCD e na Porta P1.',CR,LF,0
MSG_LCD_02:     DB              'REC = ',0
MSG_SER_03:     DB              'Teste transmissao e recepcao Serial. Colocar pinos 2 e 3 em curto.',CR,LF,0
MSG_LCD_03:     DB              'TX e RX',0
MSG_SER_04:     DB              'Teste transmissao e recepcao Serial. Mostra no LCD, P1 e ecoa pela serial.',CR,LF,0
MSG_LCD_04:     DB              'ECO',0
MSG_SER_05:     DB              'Teste escrita na RAM. MOVX @5555H,#55H.',CR,LF,0
MSG_LCD_05:     DB              '5555 55',0
MSG_SER_06:     DB              'Teste escrita na RAM. MOVX @2AAAH,#AAH.',CR,LF,0
MSG_LCD_06:     DB              '2AAA AA',0
MSG_SER_07:     DB              'Testar toda RAM1 - 32 KB. Escreve numeros de 150 ate 0 e depois confere.',CR,LF,0
MSG_LCD_07:     DB              'RAM1=32K',0
MSG_SER_08:     DB              'Testar toda RAM1 - 8 KB. Escreve numeros de 150 ate 0 e depois confere.',CR,LF,0
MSG_LCD_08:     DB              'RAM1=8K',0
MSG_SER_09:     DB              'Testar toda RAM1 - 32 KB. Escreve e confere, informando os erros.',CR,LF,0
MSG_LCD_09:     DB              'RAM1=32K',0
MSG_SER_10:     DB              'Testar toda RAM1 - 8 KB. Escreve e confere, informando os erros.',CR,LF,0
MSG_LCD_10:     DB              'RAM1=8K',0
MSG_SER_11:     DB              'Recebe endereco e dado. Fica escrevendo e lendo esse dado.',CR,LF,0
MSG_LCD_11:     DB              'End,dado',0
MSG_SER_12:     DB              'Teste do LCD, escreve ABCD... e fica circulando.',CR,LF,0
MSG_SER_13:     DB              'Teste do LCD, recebe um  caracter e o escreve continuamente no LCD.',CR,LF,0
MSG_LCD_13:     DB              'Char = ?',0
MSG_SER_14:     DB              'Teste do LCD (ROLA=0 e JANF=0), recebe caracter e escreve no LCD.',CR,LF,0
MSG_LCD_14:     DB              'rolajanf',0
MSG_SER_15:     DB              'Teste do LCD (ROLA=0 e JANF=1), recebe caracter e escreve no LCD.',CR,LF,0
MSG_LCD_15:     DB              'rolaJANF',0
MSG_SER_16:     DB              'Teste do LCD (ROLA=1 e JANF=0), recebe caracter e escreve no LCD.',CR,LF,0
MSG_LCD_16:     DB              'ROLAjanf',0
MSG_SER_17:     DB              'Teste do LCD (ROLA=1 e JANF=1), recebe caracter e escreve no LCD.',CR,LF,0
MSG_LCD_17:     DB              'ROLAJANF',0
MSG_SER_18:     DB              'Teste do teclado, envia SCAN CODE para o LCD e serial.',CR,LF,0
MSG_LCD_18:     DB              'Teclado?',0
MSG_SER_20:     DB              'Mostrar o valor HEXA e o caracter que o LCD exibe. SW3 incrementa contador',CR,LF,0
MSG_LCD_20:     DB              'SW3 ?',0
MSG_SER_21:     DB              'Contar a quantidade de interrupcoes.',CR,LF,0
MSG_LCD_21:     DB              'INT=',0
MSG_SER_22:     DB              'Vazio.',CR,LF,0
MSG_LCD_22:     DB              'Vazio',0
MSG_SER_23:     DB              'Controla estado do Pino TXD (P3.1).',CR,LF,0
MSG_LCD_23:     DB              'TXD=',0
MSG_SER_24:     DB              'Teste do teclado, envia SCAN CODE para o LCD e serial.',CR,LF,0
MSG_LCD_24:     DB              'Teclado?',0
MSG_SER_25:     DB              'Teste do teclado, identifica tecla envia para o LCD e serial.',CR,LF,0
MSG_LCD_25:     DB              'Teclado?',0
MSG_SER_26:     DB              'Teste de velocidade (28.800) serial, receber 55H 0AAH constantemente.',CR,LF,0
MSG_LCD_26:     DB              'RX 28800',0

;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                     MODO_TESTE                                     ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
MODO_TESTE:	MOV	TMOD,#21H		;TIMER1 MODO2, TIMER0 MODO 1
		MOV	TH1,#BAUD_28800	;BAUD = 28800
		MOV	TL1,#BAUD_28800
		MOV	TL0,#LOW  REC50MS	;GERAR OS 50 mSEG
		MOV	TH0,#HIGH REC50MS	;GERAR OS 50 mSEG
		MOV	SCON,#0C8H	;8 DADOS,1 START,2 STOP
		MOV	TCON,#50H		;TR0=1 e TR1=1

		SETB	ET0
		SETB	EA

		LCALL	LCD_ESTA_OK	;VERIFICAR SE O LCD EST PRESENTE E FUNCIONANDO
		
		MOV	OPTESTE,#0H
TESTE_ENTRADA:	LCALL	APAGA_LEDS
		LCALL	ACENDE_AM		;ACENDER LED AMARELO	
		LCALL	LCD_INIC		;INICIALIZAR O LCD
		MOV	DPTR,#MSG_LCD_SEL_1
		LCALL	LCD_STRC
		MOV	A,#40H
		LCALL	LCD_DDRAM
		MOV	DPTR,#MSG_LCD_SEL_2
		LCALL	LCD_STRC
		LCALL	OP_LCD1
		MOV	DPTR,#MSG_SER_SEL_1
		LCALL	SER_STRC
		LCALL	OP_SER
		LCALL	SW4_FECH_AB	;ESPERAR SOLTAR SW4
		;
		MOV	R7,#REBOTE_SW4	;DEBOUNCE SW4
		MOV	R6,#REBOTE_SW1	;DEBOUNCE SW1
TE1:		JB	SW4,TE2
		DJNZ	R7,TE1
		MOV	A,OPTESTE		;SW3 ACIONADA
		ADD	A,#1
		DA	A
		MOV	OPTESTE,A
		LCALL	OP_LCD1
		LCALL	OP_SER
		LCALL	SW4_FECH_AB		;AGUARDAR SOLTAR SW3
		SJMP	TE1
TE2:		MOV	R7,#REBOTE_SW4	;SW3 SOLTA
		JB	SW1,TE3
		DJNZ	R6,TE1
		LJMP	SEL_TESTE
TE3:		MOV	R6,#REBOTE_SW1
		SJMP	TE1
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;		SEL_TESTE					;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SEL_TESTE:      LCALL           LCD_APAGA
                MOV             DPTR,#MSG_LCD_SEL_3
                LCALL           LCD_STRC
                LCALL           OP_LCD2
                MOV             DPTR,#MSG_SER_SEL_3
                LCALL           SER_STRC
                MOV             A,OPTESTE
                LCALL           SER_BCD2
                LCALL           SER_CRLF
                MOV             A,#40H
                LCALL           LCD_DDRAM
                MOV             A,OPTESTE
                CJNE            A,#00H,ST01
                LJMP            TESTE_00
ST01:           CJNE            A,#01H,ST02
                LJMP            TESTE_01
ST02:           CJNE            A,#02H,ST03
                LJMP            TESTE_02
ST03:           CJNE            A,#03H,ST04
                LJMP            TESTE_03
ST04:           CJNE            A,#04H,ST99
                LJMP            TESTE_04
;
; Opcoes ainda nao previstas
ST99:           MOV             DPTR,#MSG_LCD_SEL_9
                LCALL           LCD_STRC
                MOV             DPTR,#MSG_SER_SEL_9
                LCALL           SER_STRC
                LCALL           SW1_FECH_AB
                LJMP            TESTE_ENTRADA
;
; TESTE_00:
; Fica saltando para o mesmo endereco. Verificar os barramentos
; So' sai com RESET
TESTE_00:       MOV             DPTR,#MSG_LCD_00
                LCALL           LCD_STRC
                MOV             DPTR,#MSG_SER_00
                LCALL           SER_STRC
                LJMP            T_00_1

T_00_1:		SJMP	$	;DEPOIS MUDAR PARA 1FAH

;
; TESTE_01:
; Fica enviando o caracter  pela porta serial com a freq de 10 Hz
TESTE_01:       MOV             DPTR,#MSG_LCD_01
                LCALL           LCD_STRC
                MOV             DPTR,#MSG_SER_01
                LCALL           SER_STRC
                MOV             A,#55H
T01_2:          MOV             CDT,#0          ;APAGAR FLAGS DE TEMPO
                LCALL           SER_CHAR
                JNB             SW1,T01_1
                LJMP            TESTE_ENTRADA
T01_1:          JNB             CDT.5,$        ;AGUARDAR O TEMPO
                SJMP            T01_2
;
; TESTE_02:
; Receber um caracter pela porta serial, mostrar no LCD e em P1
TESTE_02:       MOV             DPTR,#MSG_LCD_02
                LCALL           LCD_STRC
                MOV             DPTR,#MSG_SER_02
                LCALL           SER_STRC
                SETB            REN
                CLR             RI
T02_1:          JB              RI,T02_2
                JNB             SW1,T02_1
                CLR             REN
                LJMP            TESTE_ENTRADA
T02_2:          CLR             RI
                MOV             A,#46H
                LCALL           LCD_DDRAM
                MOV             A,SBUF
                MOV             P1,A
                LCALL           LCD_CHAR
                SJMP            T02_1
;
; TESTE_03:
; Transmite e recebe o mesmo dado (de 0 a 255) pela porta serial.
; RD_VD piscando = tudo PK
; RD_VM piscando = erro
;
TESTE_03:       MOV             DPTR,#MSG_LCD_03
                LCALL           LCD_STRC
                MOV             DPTR,#MSG_SER_03
                LCALL           SER_STRC
                SETB            REN
                CLR             RI
                CLR             TI
                MOV             B,#0
T03_1:          MOV             SBUF,B
T03_2:          JB              TI,T03_3
                JNB             SW1,T03_2
                SJMP            T03_5
T03_3:          CLR             TI
T03_4:          JB              RI,T03_6
                JNB             SW1,T03_4
T03_5:          CLR             REN
                CLR             RI
                CLR             PISCA_VD
                CLR             PISCA_VM
                LJMP            TESTE_ENTRADA
T03_6:          CLR             RI
                SETB            PISCA_VD
                MOV             A,SBUF
                XRL             A,B
                JZ              T03_7
                SETB            PISCA_VM
T03_7:          INC             B
                SJMP            T03_1
;
; TESTE_04:
; Ecoa pela porta serial tudo que recebe e ainda coloca no LCD e P1.
;
TESTE_04:       MOV             DPTR,#MSG_LCD_04
                LCALL           LCD_STRC
                MOV             DPTR,#MSG_SER_04
                LCALL           SER_STRC
                SETB            REN
                CLR             TI
                CLR             RI
T04_1:          JB              RI,T04_2
                JNB             SW1,T04_1
                SJMP            T04_4
T04_2:          CLR             RI
                MOV             A,#44H
                LCALL           LCD_DDRAM
                MOV             A,SBUF
                MOV             SBUF,A
                MOV             P1,A
                LCALL           LCD_CHAR
T04_3:          JB              TI,T04_5
                JNB             SW1,T04_3
T04_4:          CLR             REN
                LJMP            TESTE_ENTRADA
T04_5:          CLR             TI
                SJMP            T04_1


;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                   OP_LCD1 E OP_LCD2                                ;
; Imprime opcao de Teste no LCD                                      ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
OP_LCD1:        MOV             A,#46H
                LCALL           LCD_DDRAM
OP_LCD2:        MOV             A,OPTESTE
                LCALL           LCD_BCD2
                RET
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                        OP_SER                                      ;
; Imprime opcao de Teste na Porta Serial                             ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
OP_SER:         MOV             DPTR,#MSG_SER_SEL_2
                LCALL           SER_STRC
                MOV             A,OPTESTE
                LCALL           SER_BCD2
                LCALL           SER_CRLF
                RET